#line 1 "bar.yc"
#include "abcp_.h"
/*
  Bar parsing

  only the following bars are "standard":

 .|
  |
  ||
  [

  [|
  |]

  []
  [|]


    |


  but any mix of |[] and . are ok.

  Bars may be preceeded and followed by a string of ':', each signify a repetition.

  If only colons are encountered they are split according the following rules:

  if there is only one ':' then ends and starts are 2
  '::' is equivalent to ':|:'

*/


int abc_Bar(abcScanner *s, unsigned char *st,unsigned short ln)
{
  unsigned short n=0;
  unsigned char *t;

  if (ln > 0) {
    t=st;
    while (*t == ':') {
      abcBar(s,ends)++;
      t++;
      ln--;
    }
    abcBar(s,string_len) = ln;
    abcBar(s,string) = t;
    if (ln == 0) {
      if (abcBar(s,ends) > 1)
        abcBar(s,ends) = abcBar(s,ends) >> 1;
      abcBar(s,starts) = abcBar(s,ends);
    }
    else {
      t += ln;
      while (t>abcBar(s,string) && (t[-1] == ':')) {
        abcBar(s,starts)++;
        t--;
        ln--;
      }
      abcBar(s,string_len) = ln;
    }
    abcBar(s,starts)++;
    abcBar(s,ends)++;
  }
  abc_SetToken(s,T_BAR);
  return 0;
}

