#line 1 "tempo.yc"
#include "abcp_.h"
/*

 Q: [1/8 [2/8 [ 3/8 [4/8]]] =] <num1>] ["string"]
 Q: ["string"] [1/8 [2/8 [ 3/8 [4/8]]] =] <num1>]
 Q: C<num0>=<num1>

 Q:3=120
 Q:C=80
 Q:C3/4=90
 Q:C4=140

*/


int abc_gcd (unsigned long a, unsigned long b)
{
  int r;
    do {
      r = a % b;
      a = b;
      b = r;
    } while (r > 0) ;
    return a;
}

int abc_FieldTempo(abcScanner *s)
{
  unsigned long nums[5];
  unsigned long dens[5];
  unsigned long n=0,i;

 for (i=0; i<4; i++) {
   nums[i] = 0;
   dens[i] = 0;
 }

  YYSTATE (tempo) {

    if (abc_isFieldEnd(s)) YYGOTO(rationalize);
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_( "YYEOL", "" )
        ":Q\3\0",
_Y_(  2,"\Q" )
        ":!\0",
_Y_(  3,"C" )
        ":QC\0",
_Y_(  4,"\\\s+%.*" )
        ":Q\134F/F\0Q%/J\0\0",
_Y_(  5,"\s+" )
        ":F/F\0\0",
_Y_(  6,"(\d+)\s*/\s*(\d+)" )
        ":<\1D/D\0>\1/F\0Q//F\0<\2D/D\0>\2\0",
_Y_(  7,"(\d+)" )
        ":<\1D/D\0>\1\0",
_Y_(  8,"=\s*(\d+)" )
        ":Q=/F\0<\1D/D\0>\1\0",
_Y_(  9,"\Y%(.*)" )
        ":(Q%<\1/J\0>\1\0",
_Y_( 10,"." )
        ":J\0",
    NULL};
#line 41
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

      case -1 : s->nextstate = S_EOF;
      case 1 : YYGOTO(rationalize);

      case 2 : abcTempo(s,mark)     = YYSTART(0)+1;
             abcTempo(s,mark_len) = YYLEN(0) - 2;
             #ifdef ABC_STR_TEMPO
               i=abc_ChkNString(abcTempo(s,mark),abcTempo(s,mark_len));
               if ( (i & 0xFF00) == 0x0B00) abcTempo(s,code) = i;
             #endif
             break;

      case 3 : abcTempo(s,isRelative) = 1;
                   break;

      case 4 : abc_eatSOL(abcStream(s));
      case 5 : break;

      case 6 : 	 dens[n] = atoi(YYSTART(2)) & 0xFF;
      case 7 :               nums[n] = atoi(YYSTART(1)) & 0xFF;
                            if (dens[n] == 0) dens[n] = 1;
                             if (n<5) n++;
                             break;

      case 8 :           abcTempo(s,beats) = atoi(YYSTART(1));
                             break;

      case 9 :         abc_SetToken(s,T_COMMENT);
                         abcComment(s,string) =YYSTART(1);
                         abcComment(s,string_len) = YYLEN(1);
                         YYGOTO(rationalize);
      case 10 : break;

    }} /* abcStream(s */

    YYGOTO(tempo);
  }

  YYSTATE (rationalize) {

   if (abcTempo(s,beats) == 0 && n>0) {
      abcTempo(s,beats) = nums[--n];
      nums[n]=0;
      dens[n]=0;
   }
   abcTempo(s,note) = 0;
   if (n>0) {
     for (i=0; i<4 && nums[i]; i++) {
        abcTempo(s,notes)[i] = (int)((nums[i] * abcTICKS)/dens[i]);
        abcTempo(s,note) += abcTempo(s,notes)[i];
     }
    }
   if (abcTempo(s,note) == 0) {
     abcTempo(s,note) = (1 * abcTICKS);
   }
  }
  return 0;
}

