#line 1 "tokens.yc"
#define NOEXTERN

#include "abcp_.h"

static int abc_incl(abcScanner *s,unsigned char *str,unsigned short len);


unsigned short ABCAPI abcNextToken(abcScanner *s)
{
  int res = -1;


  if ((s == NULL) || (s->state == S_EOF)) {
     return T_EOF;
  }

  /* Change to a new state if required */
  switch (s->nextstate) {
    case S_NONE   : break;
    case S_EATSOL : abc_eatSOL(abcStream(s));
                    break;
    case S_INCLUDE:
                    abc_incl(s,abcXField(s,value),abcXField(s,value_len));
                    break;


    default       : s->state=s->nextstate;
  }
  s->nextstate = S_NONE;

  switch (s->state & S_CLEARIN) {
    case S_EOF           : abc_SetEmptyToken(s,T_EOF);
                           return T_EOF; break;
    case S_LIMBO         : res = abcSLimbo(s);      break;
    case S_TUNE          : res = abcSTune(s);       break;
    case S_FIELD         : res = abcSField(s);      break;
    case S_EXTFIELD      : res = abcSExtField(s);   break;
    case S_FIELD   | 'w' : res = abcSWords(s);      break;
    case S_FIELD   | 's' : res = abcSSymbols(s);    break;
    case S_TEXT          : res = abcSText(s);       break;
  }

  if (res == -1) {
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_( "YYEOL", "" )
        ":Q\3\0",
_Y_(  2,"." )
        ":J\0",
    NULL};
#line 44
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
      case -1 : if (abc_delstream(s) == NULL) {
                s->state    = S_EOF;
                abc_SetEmptyToken(s,T_EOF);
              }
              else
                abc_SetEmptyToken(s,T_INCLUDE_EOF);
              break;

      case 1 : abc_SetToken(s,T_ENDLINE);
              break;

      case 2 : abc_SetToken(s,(s->state == S_EOF)?T_EOF:T_UNKNOWN);
              break;
    }} /* abcStream(s */

  }
  return s->token;
}

const char * ABCAPI abcTokString(abcScanner *s)
{
  if (s->tokstart && s->toklen>0)
    return(s->tokstart);
  return abcEMPTYSTR;
}

static int abc_incl(abcScanner *s,unsigned char *str,unsigned short len)
{
  char fname[512];
  char *t=fname;

  if (len > 511) len=511;
  while (len>0) { *t++=*str++; len--;}
  *t='\0';
  /*printf("About to include: \"%s\"\n",fname);*/
  abc_addfilestream(s, fname,s->stream->size);
  return 0;
}

int ABCAPI abcStopInclude(abcScanner *s)
{
  if (s->nextstate == S_INCLUDE) s->nextstate=S_NONE;
  return 0;
}
