#line 1 "tune.yc"
#include "abcp_.h"
static int abc_sym(abcScanner *s, char syms);

int abcSTune(abcScanner *s)
{
  char *t;
  unsigned short n=0,d=0;
  short b;
  char matched;

  if (s == NULL || s->state == S_EOF) return -1;

  YYSTATE(tune) {
    n=0;
    matched=1;
    abc_ZEROVAL(s);
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\[(\a):\Y" )
        ":Q[<\1G>\1Q:(\0",
_Y_(  2,"[\02\n]\Y(\a):" )
        ":\200\1\4\4(<\1G>\1Q:\0",
_Y_(  3,"^\Y%%" )
        ":Q\2(S%%\0\0",
_Y_(  4,"^?\Y%\Y(.*)\|$" )
        ":-Q\2\0(Q%(<\1/J\0>\1\42Q\3\0",
_Y_(  5,"^\Y$" )
        ":Q\2(Q\3\0",
_Y_( "YYSOL", "" ) 
        ":Q\2\0",
_Y_( "YYEOL", "" )
        ":Q\3\0",
_Y_(  8,"`+" )
        ":Q`/Q`\0\0",
_Y_(  9,"\y\Y" )
        ":M(\0",
_Y_( 10,"\n" )
        ":Q\12\0",
_Y_( 11,"\\\y\Y%\Y(.*)$" )
        ":Q\134M(Q%(<\1/J\0>\1Q\3\0",
_Y_( 12,"(&+)([()]?)" )
        ":<\1Q&/Q&\0>\1<\2-\205\5\3\0>\2\0",
_Y_( 13,"{/?" )
        ":S{\0-Q/\0\0",
_Y_( 14,"}" )
        ":Q}\0",
_Y_( 15,"\(([_^]+)(\d*)(/*)(\d*)([',]?)\)[A-Ga-g]" )
        ":Q(<\1\213\13\300/\213\13\300\0>\1<\2/D\0>\2<\3/Q/\0>\3<\4/D\0>\4<\5-\204\5\200\20\0>\5Q)\210\14\376\0\0\0\376\0",
_Y_( 16,"([_^]+)(\d*)(/*)(\d*)([',]?)[A-Ga-g]" )
        ":<\1\213\13\300/\213\13\300\0>\1<\2/D\0>\2<\3/Q/\0>\3<\4/D\0>\4<\5-\204\5\200\20\0>\5\210\14\376\0\0\0\376\0",
_Y_( 17,"(=?)[A-Ga-g]" )
        ":<\1-Q=\0>\1\210\14\376\0\0\0\376\0",
_Y_( 18,"Z(\d*)" )
        ":QZ<\1/D\0>\1\0",
_Y_( 19,"[xz]" )
        ":\217\17\5\0",
_Y_( 20,"y(\d*)([cimp]?)" )
        ":Qy<\1/D\0>\1<\2-\214\16\10\42\1\0>\2\0",
_Y_( 21,"\(\d+:?(\d*):?(\d*)" )
        ":Q(D/D\0-Q:\0<\1/D\0>\1-Q:\0<\2/D\0>\2\0",
_Y_( 22,"<+" )
        ":Q</Q<\0\0",
_Y_( 23,">+" )
        ":Q>/Q>\0\0",
_Y_( 24,"\.?[-(][',]?" )
        ":-Q.\0\205\5!-\204\5\200\20\0\0",
_Y_( 25,"\)" )
        ":Q)\0",
_Y_( 26,"\[?(\d+)" )
        ":-Q[\0<\1D/D\0>\1\0",
_Y_( 27,"\[\|[^]|:]" )
        ":Q[\42\247o\373\377\377\377\337\377\377\377\357\0",
_Y_( 28,"\]\|[^]|:]" )
        ":Q]\42\247o\373\377\377\377\337\377\377\377\357\0",
_Y_( 29,"\.?[]:|[]*[]:|]" )
        ":-Q.\0/\207\17\4\0\0\0(\0\0\0\20\0\207\17\4\0\0\0 \0\0\0\20\0",
    NULL};
#line 17
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

      case -1 : abc_SetEmptyToken(s,T_EOF);
                         s->nextstate=S_EOF; return 0;

      case 1 : abc_setInField(s);
      case 2 : return abc_Field(s,YYSTART(0),*YYSTART(1),T_FIELD);

      case 3 : return abcSExtField(s);


      case 4 :
                         abc_SetToken(s,T_COMMENT);
                         abcComment(s,string) =YYSTART(1);
                         abcComment(s,string_len) = YYLEN(1);
                         return 0;

      case 5 : abc_SetEmptyToken(s,T_EMPTYLINE);
                          s->nextstate=S_LIMBO;
                          return 0;

      case 6 : YYGOTO(tune);

      case 7 : abc_SetEmptyToken(s,T_ENDLINE);
                          s->toklen=0;
                          return 0;

      case 8 : abcSpace(s,type) = 'B';
      case 9 : abc_SetToken(s,T_SPACE);
                          if (abcSpace(s,type) == '\0') abcSpace(s,type) = 'W';
                          abcSpace(s,spaces)=YYLEN(0);
                          return 0;

      case 10 : abc_SetToken(s,T_CONTINUE);
                          return 0;

      case 11 : abc_SetToken(s,T_CONTINUE);
                          s->val.comment.string=YYSTART(1);
                          s->val.comment.string_len=YYLEN(1);
                          s->nextstate=S_EATSOL;
                          return 0;


      case 12 : s->token=T_OVERLAY;
                          if (YYLEN(1)>1) s->token += 3;
                          switch (*YYSTART(2)) {
                           case '(': s->token++;
                           case ')': s->token++;
                          }
                          s->tokstart =YYSTART(0);
                          s->toklen  = YYLEN(0);
                          return 0;

      case 13 : if (YYLEN(0) > 1)
                            s->token=T_ACCIACATURA;
                          else
                            s->token=T_APPOGGIATURA;
                          s->tokstart =YYSTART(0);
                          s->toklen  = YYLEN(0);
                          return 0;

      case 14 : abc_SetToken(s,T_GRACEEND);
                          return 0;

/**----*/

     /*   1       2   3    4    5  */
      case 15 :
        case 16 :
        case 17 :
                          s->tokstart=YYSTART(0);
                          s->val.note.bending = (*YYSTART(0) == '(')?'s':'n';
                          abcNote(s,pitch) = *(YYEND(0)-1);
                          t=YYSTART(1);
                          b=0; n=1; d=1;
                          if (YYLEN(1) > 0) {
                            if (abcNote(s,bending) == 'n')
                               abcNote(s,bending) = 'b';
                            switch (t[0]) {
                              case '_' : b = -1 ; break; /* flat    */
                              case '=' : b =  0 ; break; /* natural */
                              case '^' : b =  1 ; break; /* sharp   */
                            }
                            if (YYLEN(1) > 1) {
                              if (t[0] == t[1]) {
                                b *= 2;
                              }
                              else {
                                n = 1;
                                d = 2;
                              }
                            }
                          }

                          if (YYLEN(2)>0) n = atoi(YYSTART(2));
                          if (YYLEN(3)>0) d = 1<<YYLEN(3);
                          if (YYLEN(4)>0) d = atoi(YYSTART(4));

                          if (YYLEN(5)>0) {
                            switch (*YYSTART(5)) {
                              case '\'' : n = 3; break;
                              case ','  : n = 1; break;
                            }
                            d=4;
                          }

                          s->val.note.bend = (int)((b * n * 8192) / d);

                          return abc_Note(s);

      case 18 : s->val.rest.type    = *YYSTART(0);
                          s->val.rest.duration = (YYLEN(1)>0)?atoi(YYSTART(1)):1;
                          abc_SetToken(s,T_REST);
                          return 0;

      case 19 : return(abc_Rest(s,YYSTART(0)));

      case 20 : if (YYLEN(1) > 0) s->val.spacer.space = atoi(YYSTART(1));
                          if (YYLEN(2) > 0) s->val.spacer.unit  = *YYSTART(2);
                          abc_SetToken(s,T_SPACER);
                          return 0;

      case 21 :
                          s->val.tuplet.notes = atoi(YYSTART(0)+1);
                          if (YYLEN(1) > 0) s->val.tuplet.time = atoi(YYSTART(1));
                          if (YYLEN(2) > 0) s->val.tuplet.span  = atoi(YYSTART(2));
                          abc_SetToken(s,T_TUPLET);
                          return 0;


      case 22 :
      case 23 : abcBroken(s,type) = *YYSTART(0);
                          abcBroken(s,dots) = YYLEN(0);
                          abc_SetToken(s,((abcBroken(s,type) == '<') ? T_BROKENLEFT : T_BROKENRIGHT));
                          return 0;

      case 24 : t=YYSTART(0); n=0;
                          if (t[n] == '.') s->val.slur.isDotted=t[n++];
                          s->val.slur.type=t[n++];
                          if (YYLEN(0) > n)
                            abcSlur(s,direction) = (t[n] == ',') ? 'D': 'U';
                          abc_SetToken(s,((s->val.slur.type == '-') ? T_TIE : T_SLURSTART));
                          return 0;

      case 25 : abc_SetToken(s,T_SLUREND);
                          return 0;

      case 26 : abcEnding(s,num) = atoi(YYSTART(1));
                          abc_SetToken(s,T_ENDING);
                          return 0;

      case 27 : abc_SetToken(s,T_CHORDSTART);
                          return 0;

      case 28 : abc_SetToken(s,T_CHORDEND);
                          return 0;

      case 29 : abc_Bar(s,YYSTART(0),YYLEN(0));
                          return 0;

   }} /* abcStream(s */

    /**----*/
   if (abc_sym(s,0)) {
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"." )
        ":J\0",
    NULL};
#line 180
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case 1 : abc_SetToken(s,T_UNKNOWN);
                          return 0;
     }} /* abcStream(s */

   }
  }
  return 0;
}


static int abc_sym(abcScanner *s, char syms) {
   static char gc[20];
   char *p=gc, *t;
     unsigned short n=0;
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\"[A-Ga-g]([b#]?)([^\"]*)/([A-G])([b#]?)\"" )
        ":Q\42\210\14\376\0\0\0\376<\1-\204\14\10\0\0\0\0\0\0\0\4\0>\1<\2/\244d\373\0>\2Q/<\3\210\10\376>\3<\4-\204\14\10\0\0\0\0\0\0\0\4\0>\4Q\42\0",
_Y_(  2,"\"[A-Ga-g]([b#]?)([^\"]*)\"" )
        ":Q\42\210\14\376\0\0\0\376<\1-\204\14\10\0\0\0\0\0\0\0\4\0>\1<\2/\244d\373\0>\2Q\42\0",
_Y_(  3,"\"" )
        ":Q\42\0",
_Y_(  4,"([~.H-Wh-w])" )
        ":<\1\205\17@\0\0\0\377\377\0\0\377\377@>\1\0",
_Y_(  5,"!([^\c\s!]+)!" )
        ":Q!<\1\200\344 \1\377\377\377\375/\200\344 \1\377\377\377\375\0>\1Q!\0",
_Y_(  6,"\+([^\c\s+]+)\+" )
        ":Q+<\1\200\345 \1\377\377\377\377\367/\200\345 \1\377\377\377\377\367\0>\1Q+\0",
_Y_(  7,"\Y|\Y" )
        ":(Q|(\0",
_Y_(  8,"\Y\x2A\Y" )
        ":(Q*(\0",
_Y_(  9,"\Y(\d+)[.):]" )
        ":(<\1D/D\0>\1\205\7B\0\4\0",
    NULL};
#line 194
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

               /* 1      2    3         4*/
      case 1 :
      case 2 :

                          s->token = syms? T_SYM_GCHORD: T_GCHORD;
                          s->tokstart=YYSTART(0);
                          s->toklen= YYLEN(0);
                          abcGChord(s,rootnote)   = toupper(*(YYSTART(0)+1));
                          abcGChord(s,rootaccidental) = (YYLEN(1) > 0)? *YYSTART(1) : 'n';

                          if (YYLEN(3)>0)
                            abcGChord(s,bassnote) = toupper(*YYSTART(3));
                          else
                            abcGChord(s,bassnote)   = abcGChord(s,rootnote);

                          if (YYLEN(4)>0)
                            abcGChord(s,bassaccidental) = toupper(*YYSTART(4));
                          else
                            abcGChord(s,bassaccidental) = abcGChord(s,rootaccidental);

                          if (YYLEN(2)>0) {
                            abcGChord(s,string) = YYSTART(2);
                            abcGChord(s,string_len) = YYLEN(2);
                            t=YYSTART(2);
                            abcGChord(s,name) = abcGChord(s,name_buf);
                            for (n=1; n<=YYLEN(2) && n<19; n++,t++) {
                              if ((*t != '(') && (*t!=')') && (*t!='/') && !isspace(*t))
                                abcGChord(s,name)[n]=*t;
                            }
                            abcGChord(s,name)[n] = '\0';
                            abcGChord(s,name_len) = n;
                          }
                          return 0;

      case 3 : return abc_Annotation(s);

      case 4 :
      case 5 :
      case 6 :abcDecoration(s,string) = YYSTART(1);
                          abcDecoration(s,braces)=0;
                          abcDecoration(s,string_len) = YYLEN(1);
                          if (YYLEN(1) >1) {
                            switch (abcDecoration(s,string)[abcDecoration(s,string_len)-1]) {
                              case '(' : abcDecoration(s,braces)  = 0x03;
                              case ')' : abcDecoration(s,braces) ^= 0x01;
                                         abcDecoration(s,string_len)--;
                                         switch (abcDecoration(s,string)[abcDecoration(s,string_len)-1]) {
                                           case '>':
                                           case '<':abcDecoration(s,string_len)++;
                                         }
                            }
                          }
                          abcDecoration(s,code)= 0;
                          abcDecoration(s,class) = 'D';
                          #ifdef ABC_STR_DECORATIONS
                            n=abc_ChkNString(abcDecoration(s,string),abcDecoration(s,string_len));
                            if ( (n & 0xF000) == 0x2000) {
                           abcDecoration(s,code)= n;
                           if ((n & 0xFF00) == 0x2800) abcDecoration(s,class)= 'P';
                           else if ((n & 0xFFF0) == 0x2EF0) abcDecoration(s,class)= 'H';
                            }
                          #endif
                          abc_SetToken(s, syms? T_SYM_DECORATION:T_DECORATION);

                          return 0;

      case 7 : if (syms) {
                           abc_SetToken(s,T_SYM_BAR);
                           return 0;
                         }

      case 8 : if (syms) {
                           abc_SetToken(s,T_SYM_BLANK);
                           return 0;
                         }

      case 9 : if (syms) {
                           abc_SetToken(s,T_SYM_VERSE);
                           abcDecoration(s,verse)=atoi(YYSTART(1));
                           return 0;
                         }
                         abcCursor(s) = YYSTART(0);
    }} /* abcStream(s */

    return 1;
}


int abcSSymbols(abcScanner *s)
{
  s->token = T_UNKNOWN;
  YYSTATE(sym) {
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y%\Y(.*)\|$" )
        ":(Q%(<\1/J\0>\1\42Q\3\0",
_Y_(  2,"\Y\\\y\Y%\Y(.*)$" )
        ":(Q\134M(Q%(<\1/J\0>\1Q\3\0",
_Y_(  3,"\y\Y" )
        ":M(\0",
_Y_( "YYEOL", "" )
        ":Q\3\0",
    NULL};
#line 287
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
      case -1 : abc_SetEmptyToken(s,T_EOF);
                         s->nextstate=S_EOF; return 0;


        case 1 : abc_SetToken(s,T_COMMENT);
                         abcComment(s,string) =YYSTART(1);
                         abcComment(s,string_len) = YYLEN(1);
                              return 0;

        case 2 :
                           abc_SetToken(s,T_SYM_CONTINUE);
                           s->val.comment.string=YYSTART(1);
                           s->val.comment.string_len=YYLEN(1);
                           s->nextstate=S_EATSOL;
                           return 0;

       case 3 : YYGOTO(sym);


        case 4 : s->nextstate = S_TUNE;
                           abc_SetEmptyToken(s,T_ENDLINE);
                           return 0;

    }} /* abcStream(s */

  }

   if (abc_sym(s,1)) {
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"." )
        ":J\0",
    NULL};
#line 315
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case 1 : abc_SetToken(s,T_UNKNOWN);
                          return 0;
     }} /* abcStream(s */

   }
  return 0;

}
