/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef BIPSQUIRREL_H
#define BIPSQUIRREL_H

#include "squirrel.h"

typedef SQInteger (*BIPIMPORTFUNC)(HSQUIRRELVM);

// sqapi
SQUIRREL_API void bip_setimportfunc(HSQUIRRELVM v, BIPIMPORTFUNC importfunc);
SQUIRREL_API void bip_setdconnectfunc(HSQUIRRELVM v, SQFUNCTION connectfunc);
SQUIRREL_API void bip_setmconnectfunc(HSQUIRRELVM v, SQFUNCTION connectfunc);

SQUIRREL_API SQUserPointer bip_getinstancetypetag(const HSQOBJECT *o);
SQUIRREL_API SQUserPointer bip_getinstanceuserpointer(const HSQOBJECT *o);
SQUIRREL_API SQInteger bip_getargcount(const HSQOBJECT *o);

// sqbaselib
SQInteger base_bip_import(HSQUIRRELVM v);
SQInteger base_bip_dconnect(HSQUIRRELVM v);
SQInteger base_bip_mconnect(HSQUIRRELVM v);

#endif // BIPSQUIRREL_H
