/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "bipsquirrel.h"
#include "sqpcheader.h"
#include "sqvm.h"
#include "sqtable.h"
#include "sqclass.h"
#include "sqfuncproto.h"
#include "sqclosure.h"

void bip_setimportfunc(HSQUIRRELVM v, BIPIMPORTFUNC importfunc)
{
    _ss(v)->_bipimportfunc = importfunc;
}

void bip_setdconnectfunc(HSQUIRRELVM v, SQFUNCTION connectfunc)
{
    _ss(v)->_bipdconnectfunc = connectfunc;
}

void bip_setmconnectfunc(HSQUIRRELVM v, SQFUNCTION connectfunc)
{
    _ss(v)->_bipmconnectfunc = connectfunc;
}

SQUserPointer bip_getinstancetypetag(const HSQOBJECT *o)
{
    SQClass *cl = _instance(*o)->_class;
    do{
        if(cl->_typetag)
            return cl->_typetag;
        cl = cl->_base;
    }while(cl != NULL);
    return NULL;
}

SQUserPointer bip_getinstanceuserpointer(const HSQOBJECT *o)
{
    return _instance(*o)->_userpointer;
}

SQInteger bip_getargcount(const HSQOBJECT *o)
{
    return _closure(*o)->_function->_nparameters;
}

SQInteger base_bip_import(HSQUIRRELVM v)
{
    if(_ss(v)->_bipimportfunc) {
        return _ss(v)->_bipimportfunc(v);
    }
    return 0;
}

SQInteger base_bip_dconnect(HSQUIRRELVM v)
{
    if(_ss(v)->_bipdconnectfunc) {
        return _ss(v)->_bipdconnectfunc(v);
    }
    return 0;
}

SQInteger base_bip_mconnect(HSQUIRRELVM v)
{
    if(_ss(v)->_bipmconnectfunc) {
        return _ss(v)->_bipmconnectfunc(v);
    }
    return 0;
}
