/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MIDIMML_H
#define MIDIMML_H

#include "midisequence.h"
#include "tinymml/mml.h"

namespace bipscript {
namespace midi {

class MML {
    ::MML mml;
    MML_OPTION mmlopt;
    Sequence *msequence;
    float ticksPerBar;
    float mmeasure;
    int mvolume;
    // for chords
    static const int MAX_CHORD_SIZE = 8;
    uint8_t chordTone[MAX_CHORD_SIZE];
    uint8_t chordSize;

  public:
    MML();
    void processNote(MML_INFO *p);
    void processRest(MML_INFO *p);
    void tempo(MML_INFO *p);
    void volume(MML_INFO *p);
    Sequence *sequence(const char *mml);
};

} // namespace midi
} // namespace bipscript

#endif // MMLREADER_H
