/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef STRESSPATTERN_H
#define STRESSPATTERN_H

#include <vector>

struct StressNote {
    float time;
    int velocity;
};

class StressPattern {
    int mdefault;
    std::vector<StressNote> stressnotes;

  public:
    StressPattern(int def) : mdefault(def) {}
    void addStress(float time, int vel) {
        StressNote sn;
        sn.time = time;
        sn.velocity = vel;
        stressnotes.push_back(sn);
    }
    int velocity(float time) {
        for (size_t i = 0; i < stressnotes.size(); i++) {
            if (std::abs(stressnotes[i].time - time) < 0.01) { // TODO: what is this value
                return stressnotes[i].velocity;
            }
        }
        return mdefault;
    }
};

#endif // STRESSPATTERN_H
