/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef PROCESSORCACHE_H
#define PROCESSORCACHE_H

#include "audioengine.h"
#include "objectcache.h"
#include "statusserver.h"

namespace bipscript {

/**
 * Cache template for resuable processors
 *
 * T must be a Processor
 */
template <class T> class ProcessorCache : public ActiveCache<T> {
    void newObject(T *obj) { AudioEngine::instance().addProcessor(obj); }

  protected:
    void removeObject(T *obj) {
        AudioEngine::instance().removeProcessor(obj);
        StatusServer &statusserver = StatusServer::instance();
        if (statusserver.active()) {
            statusserver.removeProcessor(obj);
        }
    }
};

} // namespace bipscript
#endif // PROCESSORCACHE_H
