/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef SCRIPTCOLLECTOR_H
#define SCRIPTCOLLECTOR_H

#include "collector.h"

namespace bipscript {

class ScriptCollector {
    List<GarbageCollector> mlist;
    ScriptCollector() {}

  public:
    static ScriptCollector &instance() {
        static ScriptCollector instance;
        return instance;
    }
    void addCollector(GarbageCollector *collector) { mlist.add(collector); }
    void removeCollector(GarbageCollector *collector) { mlist.remove(collector); }
    void collect() {
        GarbageCollector *q = mlist.first();
        while (q) {
            // printf("COLLETOR run %p\n", q);
            q->free();
            q = mlist.next(q);
        }
    }
};

} // namespace bipscript

#endif // SCRIPTCOLLECTOR_H
