/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef TABLETYPE_H
#define TABLETYPE_H

#include "bindutil.h"

namespace bipscript {

// adds methods to existing table class
class Table {

  public:
    static void bindType(HSQUIRRELVM vm) {
        BindUtil binding(vm);
        // pull up existing delegate table
        sq_getdefaultdelegate(vm, OT_TABLE);
        // add methods
        binding.addMethod("has", 3, Has);
        // pop delegate table
        sq_poptop(vm);
    }

  private:
#define BIND_CLASS_NAME "table"
#define BIND_METHOD_NAME "has"
    static SQInteger Has(HSQUIRRELVM vm) {
        BIND_GET_NARGS()
        BIND_NARGS_CHECK_EXACT(1)
        bool ret = SQ_SUCCEEDED(sq_get(vm, 1));
        if (ret) {
            sq_poptop(vm); // pop result
        }
        sq_pushbool(vm, ret);
        return 1;
    }
#undef BIND_METHOD_NAME
#undef BIND_CLASS_NAME
};
} // namespace bipscript

#endif // TABLETYPE_H
