/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef XTARRAY_H
#define XTARRAY_H

#include "squirrel.h"

class XtArray {
    HSQOBJECT sqarray;

  public:
    XtArray(HSQUIRRELVM vm, int size) {
        sq_newarray(vm, size);
        sq_getstackobj(vm, -1, &sqarray);
        sq_addref(vm, &sqarray); // TODO: remove ref in dtor
        sq_poptop(vm);
    }
    void appendObject(HSQUIRRELVM vm, void *obj, HSQOBJECT objtype) {
        sq_pushobject(vm, sqarray);    // array
        sq_pushobject(vm, objtype);    // array:objtype
        sq_createinstance(vm, -1);     // array:objtype:instance
        sq_setinstanceup(vm, -1, obj); // array:objtype:instance
        sq_remove(vm, -2);             // array:instance
        sq_arrayappend(vm, -2);        // array
        sq_poptop(vm);
    }
    HSQOBJECT hsqobject() { return sqarray; }
};

#endif // XTARRAY_H
